var $J = jQuery.noConflict();


//$J( document ).ready(function() {
jQuery(document).ready(function ($J) {
	// runtime events
	
	$J(".qc-income").keydown(function(event) {
		if(!(isIntegerKey(event))) event.preventDefault();
	});	

	$J(".qc-income").keyup(function( ) {
		//calculate_income_tax_qc($J(this).closest("aside").attr("id"));
        calculate_income_tax_qc(get_id(this.id,"income"));

	});

    function get_id(long_id,fieldname)
    {
        return long_id.substr(0, long_id.lastIndexOf(fieldname) - 1);
    };

    function calculate_income_tax_qc(id)
    {
        var income_id = '#' + id + '-' + 'income';
	    var income = $J(income_id).val();
        var currency = '$';
	
        // clear output
	    $J('#' + id + '-' + 'ProvincialTax').html("");
	    $J('#' + id + '-' + 'FederalTax').html("");
	    $J('#' + id + '-' + 'TotalTax').html("");
	    $J('#' + id + '-' + 'AverageRate').html("");
	    $J('#' + id + '-' + 'AfterTaxIncome').html("");

	    // if no data entered
	    if (isNaN(income) || income == "") return;
	
        // calculate QC provincial taxes 2019
	    ProvincialTax = 0; 
        tmpIncome = income;
        if (tmpIncome > 106555) { ProvincialTax += (tmpIncome - 106555) * 25.75 / 100; tmpIncome = 106555; }
        if (tmpIncome > 87575) { ProvincialTax += (tmpIncome - 87575) * 24 / 100; tmpIncome = 87575; }
        if (tmpIncome > 43790) { ProvincialTax += (tmpIncome - 43790) * 20 / 100; tmpIncome = 43790; }
        if (tmpIncome > 15269) { ProvincialTax += (tmpIncome - 15269) * 15 / 100; }
		
        // calculate Canadian federal taxes 2019
        FederalTax = 0;
        tmpIncome = income;
        if (tmpIncome > 210371) { FederalTax += (tmpIncome - 210371) * 27.56 / 100; tmpIncome = 210371; }
        if (tmpIncome > 147667) { FederalTax += (tmpIncome - 147667) * 24.22 / 100; tmpIncome = 147667; }
        if (tmpIncome > 95259) { FederalTax += (tmpIncome - 95259) * 21.71 / 100; tmpIncome = 95259; }
        if (tmpIncome > 47630) { FederalTax += (tmpIncome - 47630) * 17.12 / 100; tmpIncome = 47630; }
        if (tmpIncome > 12069) { FederalTax += (tmpIncome - 12069) * 12.53 / 100; }

        TotalTax = ProvincialTax + FederalTax;
	    AverageRate = TotalTax / income * 100;
	    if (isNaN(AverageRate)) AverageRate = 0;
	    AfterTaxIncome = income - TotalTax;
	
        $J('#' + id + '-' + 'ProvincialTax').html(currency + formatNumber(round2TwoDecimals(ProvincialTax)).toString());
        $J('#' + id + '-' + 'FederalTax').html(currency + formatNumber(round2TwoDecimals(FederalTax)).toString());
        $J('#' + id + '-' + 'TotalTax').html(currency + formatNumber(round2TwoDecimals(TotalTax)).toString());
        $J('#' + id + '-' + 'AverageRate').html(round2TwoDecimals(AverageRate).toString() + '%');
        $J('#' + id + '-' + 'AfterTaxIncome').html(currency + formatNumber(round2TwoDecimals(AfterTaxIncome)).toString());
	   
    };

});

function isIntegerKey(evt)	  
      {
         var key = evt.which || evt.which || event.keyCode;
		 // allow backspace, tab, delete, arrows, numbers and keypad numbers ONLY
		 var isInteger = (key == 8 || 
                key == 9 ||
                key == 46 ||
                (key >= 35 && key <= 40) ||
                (key >= 48 && key <= 57) ||
                (key >= 96 && key <= 105));
		return isInteger;
				
      };
	  
function isDecimalKey(e, number)
      {
         var key = (e.which) ? e.which : e.keyCode;
		 // numbers (48-57 and 96-105), dot (110,190), comma (44,188), backspace(8), tab (9), navigation keys (35-40), DEL(46)
		 if ((key >= 48 && key <= 57) || (key >= 96 && key <= 105) || key == 110 || key == 190 || key == 8 || key == 9 || (35 <= key && key <= 40) || key == 46 )  
		 	{
			 		  if (key == 110 || key == 190)
					  {
					   	 // skip it if comma or decimal point already entered or it is empty field yet
						 if (number.indexOf(".") > -1 || number.indexOf(",") > -1 || number.length == 0) 
						 	return false; 
					  }
			          return true;
			}

         return false;
      };

function radioValue(element)	  
		 {
		    var returnValue = "";
            var radios = document.getElementsByName(element);
            
            for (var i = 0, length = radios.length; i < length; i++) {
                if (radios[i].checked) {
                    returnValue = radios[i].value;
                }
			}
			return returnValue;	
		 };	  	
function round2TwoDecimals(number)
		 {
 		    return Math.round(number*100)/100						 
		 };	
 

function formatNumber (num) {
    return num.toString().replace(/(\d)(?=(\d{3})+(?!\d))/g, "$1,")
}

